/* ------------------------------------------------------------------- */
/* PT.C   :  Page Tail  : estrae un insieme di pagine da un file di    */
/*                        stampa Ascii                                 */
/*                                                                     */
/* Uso:                                                                */
/*          PT  [parametri] filein                                     */
/*                                                                     */
/* L'output e' in standard Output                                      */
/*                                                                     */
/* Parametri:   -h  o  -? : help                                       */
/*              -ipag1  inizia ad estrarre da pag1 (default=inizio file*/
/*              -fpag2  finisce di estrarre a pag2 (default=fine file) */
/*              -lnnn : lunghezza pagina (default 66 linee )           */
/*              -cnnn : invece di contare i ^L conta i caratteri che   */
/*                      hanno un valore decimale pari a 'nnn'          */
/*                                                                     */
/* PIERO  2/98                                                         */
/* ------------------------------------------------------------------- */

/* #include <io.h> */
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <string.h>

FILE *filein;

long int pagini, pagfin, numctrll, numpag, numlines, maxlenrec, linexpag = 66;
char nomein[80], linea[256];

void aiuto()
{
     printf("\nPT - Page Tail  ---------------------------------- (c) Piero Ronchi  2/1998 \n");
     printf("\n     pt  [-innn] [-fmmm] [-lnnn] [-cnnn]  filename \n");
     printf("\nEstrae dal file di stampa 'filename' le pagine nell'intervallo indicato\n");
     printf("    e le mette in Standard Output.\n");
     printf("    Parametri:    \n");
     printf("-i      specifica il numero di pagina iniziale (default inizio file)\n");
     printf("-f      specifica il numero di pagina finale   (default fine   file)\n");
     printf("-l      reimposta la lunghezza massima della pagina (default 66) \n");
     printf("        (utile se nel file non sono presenti salti pagina) \n");
     printf("-c      usa un altro carattere (di valore decimale nnn) al posto del '12'\n");
     printf("        (^L) come carattere di salto pagina.\n");
}

main(int argc, char *argv[], char *env[])
{
   char c, *ptr, flagcopy = 'N' ;
   long int i, l, k, count;

   if ( (argc <= 1) || strcmp(argv[1],"-h") == 0 ||
      strcmp(argv[1],"-?") == 0) {
      aiuto();
      exit(1);
   }
   pagini = 0, pagfin = 0, numlines = 0; numpag = 0; numctrll = 0; maxlenrec = 0;
   c = '\f';

   /* Analizza i parametri in input    */
   for (i = 1; i < argc; i++) {
      if (strncmp(argv[i], "-i", 2) == 0) {
         pagini = atoi(argv[i]+2);
         if (pagini <= 0) {
            fputs("\nPT - parametro -i errato. \n", stderr);
            exit (1);
         }
      }
      else {
         if (strncmp(argv[i], "-f", 2) == 0) {
            pagfin = atoi(argv[i]+2);
            if (pagfin <= 0) {
               fputs("\nPT - parametro -f errato. \n", stderr);
               exit (2);
            }
         }
         else {
            if (strncmp(argv[i], "-l", 2) == 0) linexpag = atoi(argv[i]+2);
                else if (strncmp(argv[i], "-c", 2) == 0) c = atoi(argv[i]+2);
                   else  strcpy (nomein, argv[i]);
         }
      }
   }
   if ((pagfin > 0) && (pagini > pagfin)) {
      fputs("\nPT - parametri incoerenti. \n", stderr);
      exit (9);
   }

   if (linexpag < 2) linexpag = 66;
   if ((filein = fopen(nomein,"r")) == NULL) {
      fputs("\nPT - Open Error.\n", stderr);
      exit(10);
   }

   /* Leggi e analizza il file di stampa   */
   l = 0; count = 0;
   if (pagini <= 1) flagcopy = 'S';
   while (fgets(linea, 255, filein) != NULL)  {
       numlines++; l++;
       k = strlen(linea);
       if (k > maxlenrec) maxlenrec = k;
       ptr = strchr (linea, c);
       while (ptr) {
          numctrll++; l = 0;
          ptr = strchr (ptr+1, c);
       }

       if ( l > linexpag ) {
          numpag++; l = 0;
       }
       count = numpag + numctrll + 1;
       if ((count >= pagini) && ((pagfin == 0) || (count <= pagfin))) {
          if (flagcopy == 'N') {
             if ( ptr = strchr (linea, c) )
                strcpy (linea, ptr + 1);
             flagcopy = 'S';
          }
          if (fputs (linea, stdout) == EOF) {
             fputs("\nPT - Write Error.\n", stderr);
             exit(11);
          }
       }
       else {
          if (flagcopy == 'S')  {
             flagcopy = 'N';
             if ( ptr = strchr (linea, c) ) {
                linea[ptr-linea] = '\0';
                if (fputs (linea, stdout) == EOF) {
                   fputs("\nPT - Write Error.\n", stderr);
                   exit(11);
                }
             }
          }
       }
       if ((pagfin > 0) && (count > pagfin)) break;
   }


   fclose (filein);
   return(0);
}
